#include <iostream>
#include "complex.hh"

extern "C" {
  void p2nspri_( double *p2plsn_r, double *p2plsn_i, 
		 double *p2minn_r, double *p2minn_i, 
		 double *p2valn_r, double *p2valn_i, 
		 double *n_r, double *n_i,
		 int *nf );
}

void p2nsp(complex *p2plsn, complex *p2minn, complex *p2valn, complex N, int nf) {
  double a1, a2, b1, b2, c1, c2;
  double nr = real(N), ni = imag(N);
  p2nspri_(&a1, &a2, &b1, &b2, &c1, &c2, &nr, &ni, &nf);
  *p2plsn = complex(a1,a2);
  *p2minn = complex(b1,b2);
  *p2valn = complex(c1,c2);
  return;
}

extern "C" {
  void p2ijpri_( double *p2psn_r, double *p2psn_i, 
		 double *p2qgn_r, double *p2qgn_i, 
		 double *p2gqn_r, double *p2gqn_i, 
		 double *p2ggn_r, double *p2ggn_i, 
		 double *n_r, double *n_i,
		 int *nf );
}

void p2ijp(complex *p2psn, complex *p2qgn, complex *p2gqn, complex *p2ggn, complex N, int nf) {
  double a1, a2, b1, b2, c1, c2, d1, d2;
  double nr = real(N), ni = imag(N);
  p2ijpri_(&a1, &a2, &b1, &b2, &c1, &c2, &d1, &d2, &nr, &ni, &nf);
  *p2psn = complex(a1,a2);
  *p2qgn = complex(b1,b2);
  *p2gqn = complex(c1,c2);
  *p2ggn = complex(d1,d2);
  return;
}


